#!/usr/bin/perl
#=============================================================

$DEBUG=1;
# 0 = sin debug (modo silencioso)
# 1 = con debug (modo verbose)
use IO::Socket;

#====================================#
# Variables
#====================================#
$SMS_HOST="sms.lleida.net:2048";
$SMS_LOGIN="##user_SMS_PREMIUM##";
$SMS_PASSWORD="##pass_SMS_PREMIUM##";
$SMS_NUM_CORTO="##numero_Short_Number##";
$SMS_CLAVE="##clave_SMS_PREMIUM##"
#====================================#
# Socket
#====================================#
if ($SOCK=IO::Socket::INET->new(PeerAddr=>$SMS_HOST, Proto=>'tcp'))
{
select (STDOUT); $| = 1;
select ($SOCK);  $| = 1;
select (STDOUT);

#====================================#
# BASE CODE
#==================================#
print $SOCK  "1 LOGIN $SMS_LOGIN $SMS_PASSWORD\n";
print STDOUT "1 LOGIN $SMS_LOGIN xxxxx\n" if $DEBUG;
print $SOCK  "2 deliver\n";

$pong=0;
while( $linia = <$SOCK> ) {
	print "->>> $linia" if $DEBUG;
	($code, $msg) = split(" ",$linia,2);

        if( $linia =~ m/ping (.*)/ ) {
		print $SOCK "$code PONG $1\n";
                $pong = 1;
		$nextcode=$code+1;
        }

	if( $linia =~ m/DELIVER (.*)/ ) {
		($code,$COMMAND,$idmsg,$FECHA,$DEST,$ORIG,$msg)=split(" ",$linia,7);
		&parsea_msg;
		print $SOCK "$code RESP $idmsg $RESPUESTA\n";
		print STDOUT "$code RESP $idmsg $RESPUESTA\n" if $DEBUG;
		$nextcode=$code+1;
		}

	if( $linia =~ m/ROK (.*)/ ) {
		print STDOUT "Respondido correctamente mensaje $1\n" if $DEBUG;
		} 
}

} else {
	print "Error conectando al servidor SMS\n";
	}

exit 0;

#################################################################################################
sub parsea_msg {
chomp($msg);
$msg=uc($msg);
$RESPUESTAOK=0;
$ACCION=0;

# TODAS LAS POSIBLES RESPUESTAS AQUI

if ($ORIG eq "$SMS_NUM_CORTO") {

	if ($msg=~ m/$SMS_CLAVE/) {
	$RESPUESTAOK=1;
	&funcion_ejemplo;
	}

}

  if ($RESPUESTAOK < 1) {
  $RESPUESTA="No se encuentra ningun concurso con esa palabra clave: Prueba a enviar DG al 5015";
  }		

}

#############################################################################
# ACCIONES EXTERNAS
# Aqu se emplazan las funciones para tratar el mensaje
#############################################################################
sub funcion_ejemplo {
$RESPUESTA="Has enviado un mensaje con el texto: $msg";
}

